# mypy-boto3-alexaforbusiness

[![PyPI - mypy-boto3-alexaforbusiness](https://img.shields.io/pypi/v/mypy-boto3-alexaforbusiness.svg?color=blue)](https://pypi.org/project/mypy-boto3-alexaforbusiness)
[![PyPI - Python Version](https://img.shields.io/pypi/pyversions/mypy-boto3-alexaforbusiness.svg?color=blue)](https://pypi.org/project/mypy-boto3-alexaforbusiness)
[![Docs](https://img.shields.io/readthedocs/mypy-boto3-builder.svg?color=blue)](https://mypy-boto3-builder.readthedocs.io/)

![boto3.typed](https://github.com/vemel/mypy_boto3_builder/raw/master/logo.png)

Type annotations for
[boto3.AlexaForBusiness 1.17.3](https://boto3.amazonaws.com/v1/documentation/api/1.17.3/reference/services/alexaforbusiness.html#AlexaForBusiness) service
compatible with
[VSCode](https://code.visualstudio.com/),
[PyCharm](https://www.jetbrains.com/pycharm/),
[Emacs](https://www.gnu.org/software/emacs/),
[Sublime Text](https://www.sublimetext.com/),
[mypy](https://github.com/python/mypy),
[pyright](https://github.com/microsoft/pyright)
and other tools.

Generated by [mypy-boto3-buider 4.4.0](https://github.com/vemel/mypy_boto3_builder).

More information can be found on [boto3-stubs](https://pypi.org/project/boto3-stubs/) page.

See how it helps to find and fix potential bugs:

![boto3-stubs demo](https://github.com/vemel/mypy_boto3_builder/raw/master/demo.gif)

- [mypy-boto3-alexaforbusiness](#mypy-boto3-alexaforbusiness)
  - [How to install](#how-to-install)
  - [Usage](#usage)
    - [VSCode](#vscode)
    - [PyCharm](#pycharm)
    - [Other IDEs](#other-ides)
    - [mypy](#mypy)
    - [pyright](#pyright)
  - [Explicit type annotations](#explicit-type-annotations)
    - [Client annotations](#client-annotations)
    - [Paginators annotations](#paginators-annotations)
    - [Waiters annotations](#waiters-annotations)
    - [Service Resource annotations](#service-resource-annotations)
    - [Other resources annotations](#other-resources-annotations)
    - [Collections annotations](#collections-annotations)
    - [Typed dictionations](#typed-dictionations)

## How to install

Install `boto3-stubs` for `AlexaForBusiness` service.

```bash
python -m pip install boto3-stubs[alexaforbusiness]
```

## Usage

### VSCode

- Install [Python extension](https://marketplace.visualstudio.com/items?itemName=ms-python.python)
- Install [Pylance extension](https://marketplace.visualstudio.com/items?itemName=ms-python.vscode-pylance)
- Set `Pylance` as your Python Language Server
- Install `boto-stubs[alexaforbusiness]` in your environment: `python -m pip install 'boto3-stubs[alexaforbusiness]'`

Both type checking and auto-complete should work for `AlexaForBusiness` service.
No explicit type annotations required, write your `boto3` code as usual.

### PyCharm

- Install `boto-stubs[alexaforbusiness]` in your environment: `python -m pip install 'boto3-stubs[alexaforbusiness]'`

Both type checking and auto-complete should work for `AlexaForBusiness` service.
No explicit type annotations required, write your `boto3` code as usual.
Auto-complete can be slow on big projects or if you have a lot of installed `boto3-stubs` submodules.

### Other IDEs

Not tested, but as long as your IDE support `mypy` or `pyright`, everything should work.

### mypy

- Install `mypy`: `python -m pip install mypy`
- Install `boto-stubs[alexaforbusiness]` in your environment: `python -m pip install 'boto3-stubs[alexaforbusiness]'`
- Run `mypy` as usual

Type checking should work for `AlexaForBusiness` service.
No explicit type annotations required, write your `boto3` code as usual.

### pyright

- Install `pyright`: `yarn global add pyright`
- Install `boto-stubs[alexaforbusiness]` in your environment: `python -m pip install 'boto3-stubs[alexaforbusiness]'`
- Optionally, you can install `boto3-stubs` to `typings` folder.

Type checking should work for `AlexaForBusiness` service.
No explicit type annotations required, write your `boto3` code as usual.

## Explicit type annotations

### Client annotations

`AlexaForBusinessClient` provides annotations for `boto3.client("alexaforbusiness")`.

```python
import boto3

from mypy_boto3_alexaforbusiness import AlexaForBusinessClient

client: AlexaForBusinessClient = boto3.client("alexaforbusiness")

# now client usage is checked by mypy and IDE should provide code auto-complete

# works for session as well
session = boto3.session.Session(region="us-west-1")
session_client: AlexaForBusinessClient = session.client("alexaforbusiness")
```

### Paginators annotations

`mypy_boto3_alexaforbusiness.paginator` module contains type annotations for all paginators.

```python
from mypy_boto3_alexaforbusiness import AlexaForBusinessClient
from mypy_boto3_alexaforbusiness.paginator import (
    ListBusinessReportSchedulesPaginator,
    ListConferenceProvidersPaginator,
    ListDeviceEventsPaginator,
    ListSkillsPaginator,
    ListSkillsStoreCategoriesPaginator,
    ListSkillsStoreSkillsByCategoryPaginator,
    ListSmartHomeAppliancesPaginator,
    ListTagsPaginator,
    SearchDevicesPaginator,
    SearchProfilesPaginator,
    SearchRoomsPaginator,
    SearchSkillGroupsPaginator,
    SearchUsersPaginator,
)

client: AlexaForBusinessClient = boto3.client("alexaforbusiness")

# Explicit type annotations are optional here
# Type should be correctly discovered by mypy and IDEs
# VSCode requires explicit type annotations
list_business_report_schedules_paginator: ListBusinessReportSchedulesPaginator = client.get_paginator("list_business_report_schedules")
list_conference_providers_paginator: ListConferenceProvidersPaginator = client.get_paginator("list_conference_providers")
list_device_events_paginator: ListDeviceEventsPaginator = client.get_paginator("list_device_events")
list_skills_paginator: ListSkillsPaginator = client.get_paginator("list_skills")
list_skills_store_categories_paginator: ListSkillsStoreCategoriesPaginator = client.get_paginator("list_skills_store_categories")
list_skills_store_skills_by_category_paginator: ListSkillsStoreSkillsByCategoryPaginator = client.get_paginator("list_skills_store_skills_by_category")
list_smart_home_appliances_paginator: ListSmartHomeAppliancesPaginator = client.get_paginator("list_smart_home_appliances")
list_tags_paginator: ListTagsPaginator = client.get_paginator("list_tags")
search_devices_paginator: SearchDevicesPaginator = client.get_paginator("search_devices")
search_profiles_paginator: SearchProfilesPaginator = client.get_paginator("search_profiles")
search_rooms_paginator: SearchRoomsPaginator = client.get_paginator("search_rooms")
search_skill_groups_paginator: SearchSkillGroupsPaginator = client.get_paginator("search_skill_groups")
search_users_paginator: SearchUsersPaginator = client.get_paginator("search_users")
```







### Typed dictionations

`mypy_boto3_alexaforbusiness.type_defs` module contains structures and shapes assembled
to typed dictionaries for additional type checking.

```python
from mypy_boto3_alexaforbusiness.type_defs import (
    AddressBookDataTypeDef,
    AddressBookTypeDef,
    AudioTypeDef,
    BusinessReportContentRangeTypeDef,
    BusinessReportRecurrenceTypeDef,
    BusinessReportS3LocationTypeDef,
    BusinessReportScheduleTypeDef,
    BusinessReportTypeDef,
    CategoryTypeDef,
    ConferencePreferenceTypeDef,
    ConferenceProviderTypeDef,
    ContactDataTypeDef,
    ContactTypeDef,
    CreateEndOfMeetingReminderTypeDef,
    CreateInstantBookingTypeDef,
    CreateRequireCheckInTypeDef,
    DeveloperInfoTypeDef,
    DeviceDataTypeDef,
    DeviceEventTypeDef,
    DeviceNetworkProfileInfoTypeDef,
    DeviceStatusDetailTypeDef,
    DeviceStatusInfoTypeDef,
    DeviceTypeDef,
    EndOfMeetingReminderTypeDef,
    GatewayGroupSummaryTypeDef,
    GatewayGroupTypeDef,
    GatewaySummaryTypeDef,
    GatewayTypeDef,
    IPDialInTypeDef,
    InstantBookingTypeDef,
    MeetingRoomConfigurationTypeDef,
    MeetingSettingTypeDef,
    NetworkProfileDataTypeDef,
    NetworkProfileTypeDef,
    PSTNDialInTypeDef,
    PhoneNumberTypeDef,
    ProfileDataTypeDef,
    ProfileTypeDef,
    RequireCheckInTypeDef,
    RoomDataTypeDef,
    RoomSkillParameterTypeDef,
    RoomTypeDef,
    SipAddressTypeDef,
    SkillDetailsTypeDef,
    SkillGroupDataTypeDef,
    SkillGroupTypeDef,
    SkillSummaryTypeDef,
    SkillsStoreSkillTypeDef,
    SmartHomeApplianceTypeDef,
    SsmlTypeDef,
    TagTypeDef,
    TextTypeDef,
    UpdateEndOfMeetingReminderTypeDef,
    UpdateInstantBookingTypeDef,
    UpdateRequireCheckInTypeDef,
    UserDataTypeDef,
    ContentTypeDef,
    CreateAddressBookResponseTypeDef,
    CreateBusinessReportScheduleResponseTypeDef,
    CreateConferenceProviderResponseTypeDef,
    CreateContactResponseTypeDef,
    CreateGatewayGroupResponseTypeDef,
    CreateMeetingRoomConfigurationTypeDef,
    CreateNetworkProfileResponseTypeDef,
    CreateProfileResponseTypeDef,
    CreateRoomResponseTypeDef,
    CreateSkillGroupResponseTypeDef,
    CreateUserResponseTypeDef,
    FilterTypeDef,
    GetAddressBookResponseTypeDef,
    GetConferencePreferenceResponseTypeDef,
    GetConferenceProviderResponseTypeDef,
    GetContactResponseTypeDef,
    GetDeviceResponseTypeDef,
    GetGatewayGroupResponseTypeDef,
    GetGatewayResponseTypeDef,
    GetInvitationConfigurationResponseTypeDef,
    GetNetworkProfileResponseTypeDef,
    GetProfileResponseTypeDef,
    GetRoomResponseTypeDef,
    GetRoomSkillParameterResponseTypeDef,
    GetSkillGroupResponseTypeDef,
    ListBusinessReportSchedulesResponseTypeDef,
    ListConferenceProvidersResponseTypeDef,
    ListDeviceEventsResponseTypeDef,
    ListGatewayGroupsResponseTypeDef,
    ListGatewaysResponseTypeDef,
    ListSkillsResponseTypeDef,
    ListSkillsStoreCategoriesResponseTypeDef,
    ListSkillsStoreSkillsByCategoryResponseTypeDef,
    ListSmartHomeAppliancesResponseTypeDef,
    ListTagsResponseTypeDef,
    PaginatorConfigTypeDef,
    RegisterAVSDeviceResponseTypeDef,
    ResolveRoomResponseTypeDef,
    SearchAddressBooksResponseTypeDef,
    SearchContactsResponseTypeDef,
    SearchDevicesResponseTypeDef,
    SearchNetworkProfilesResponseTypeDef,
    SearchProfilesResponseTypeDef,
    SearchRoomsResponseTypeDef,
    SearchSkillGroupsResponseTypeDef,
    SearchUsersResponseTypeDef,
    SendAnnouncementResponseTypeDef,
    SortTypeDef,
    UpdateMeetingRoomConfigurationTypeDef,
)

def get_structure() -> AddressBookDataTypeDef:
    return {
      ...
    }
```
